exec("./Support_TCPClient.cs");
if(!isObject(BLCheckGui))
	exec("./BLCheckGui.gui");

if(!isObject($TCPClient::BLCheckOptions))
{
	$TCPClient::BLCheckOptions = new ScriptObject(TCPClientBlCheckOption)
	{
		class = TCPClientOptions;
		connectionTimeout = 10000;
		connectionRetryWait = 2000;
		connectionRetryCount = 3;
		redirectWait = 500;
		debug = false;
		printErrors = false;
	};
}

if(!isObject(MM_AuthMouseEvent))
{
	new GuiMouseEventCtrl(MM_AuthMouseEvent)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "0 0";
		extent = MM_AuthBar.getExtent();
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		lockMouse = "0";
	};
	MM_AuthBar.add(MM_AuthMouseEvent);
	MM_AuthBar.pushToBack(MM_AuthKeyButton);
	MM_AuthBar.pushToBack(MM_AuthRetryButton);
	MM_AuthBar.pushToBack(MM_AuthNameButton);
}

function MM_AuthMouseEvent::onMouseUp(%gui)
{
	BLChecker_OpenGui();
}

function BLChecker_OpenGui()
{
	canvas.pushDialog(BLCheckGui);
	BLChecker_CheckAll();
}

function BLCheck_GetResults(%type)
{
	%error = $TCPClient::TCPError[%type];
	switch$(%type)
	{
		case "Auth":
			if(%error == -1)
				MessageBoxOK("Is it down? - Authentication", "You are NOT supposed to see this message.");
			else if(%error == $TCPClient::Error::dnsFailed)
				MessageBoxOK("Is it down? - Authentication", "The connection is you, you are unable to connect to the authentication server.");
			else if(%error == $TCPClient::Error::connectionFailed || %error == $TCPClient::Error::connectionTimedOut)
				MessageBoxOK("Is it down? - Authentication", "The connection is not you!\nThe authentication server is not responding.");
			else if(%error == $TCPClient::Error::invalidResponse || %error == 0)
				MessageBoxOK("Is it down? - Authentication", "The authentication server is up.");
			else
				MessageBoxOK("Is it down? - Authentication", "Got a strange error. (" @ %error @ ")");

		case "Forum":
			if(%error == -1)
				MessageBoxOK("Is it down? - Forums", "You are NOT supposed to see this message.");
			else if(%error == $TCPClient::Error::dnsFailed)
				MessageBoxOK("Is it down? - Forums", "The connection is you, you are unable to connect to the forums.");
			else if(%error == $TCPClient::Error::connectionFailed || %error == $TCPClient::Error::connectionTimedOut)
				MessageBoxOK("Is it down? - Forums", "The connection is not you!\nThe forums are not responding.");
			else if(%error == $TCPClient::Error::invalidResponse || %error == 0)
				MessageBoxOK("Is it down? - Forums", "The forums are up.");
			else
				MessageBoxOK("Is it down? - Forums", "Got a strange error. (" @ %error @ ")");

		case "Master":
			if(%error == -1)
				MessageBoxOK("Is it down? - Master server", "You are NOT supposed to see this message.");
			else if(%error == $TCPClient::Error::dnsFailed)
				MessageBoxOK("Is it down? - Master server", "The connection is you, you are unable to connect to the master server.");
			else if(%error == $TCPClient::Error::connectionFailed || %error == $TCPClient::Error::connectionTimedOut)
				MessageBoxOK("Is it down? - Master server", "The connection is not you!\nThe master server is not responding.");
			else if(%error == $TCPClient::Error::invalidResponse || %error == 0)
				MessageBoxOK("Is it down? - Master server", "The master server is up.");
			else
				MessageBoxOK("Is it down? - Master server", "Got a strange error. (" @ %error @ ")");

		case "Main":
			if(%error == -1)
				MessageBoxOK("Is it down? - Blockland.us", "You are NOT supposed to see this message.");
			else if(%error == $TCPClient::Error::dnsFailed)
				MessageBoxOK("Is it down? - Blockland.us", "The connection is you, you are unable to connect to Blockland's website.");
			else if(%error == $TCPClient::Error::connectionFailed || %error == $TCPClient::Error::connectionTimedOut)
				MessageBoxOK("Is it down? - Blockland.us", "The connection is not you!\nThe website is not responding.");
			else if(%error == $TCPClient::Error::invalidResponse || %error == 0)
				MessageBoxOK("Is it down? - Blockland.us", "The Blockland website is up.");
			else
				MessageBoxOK("Is it down? - Blockland.us", "Got a strange error. (" @ %error @ ")");
	}
}

function BLChecker_CheckAll()
{
	//connectToURL(%url, %method, %savePath, %class, %options);

	if(!$TCPClient::isTCPReady["Auth"])
	{
		BLCheck_Reset("Auth");
		$TCPClient::isTCPReady["Auth"] = 1;
		connectToURL("http://auth.blockland.us/index.php", "GET", "", "TCPBLCheck",    $TCPClient::BLCheckOptions).mType   = "Auth";
	}

	if(!$TCPClient::isTCPReady["Forum"])
	{
		BLCheck_Reset("Forum");
		$TCPClient::isTCPReady["Forum"] = 1;
		connectToURL("http://forum.blockland.us/index.php", "GET", "", "TCPBLCheck",   $TCPClient::BLCheckOptions).mType  = "Forum";
	}

	if(!$TCPClient::isTCPReady["Master"])
	{
		BLCheck_Reset("Master");
		$TCPClient::isTCPReady["Master"] = 1;
		connectToURL("http://master2.blockland.us/index.php", "GET", "", "TCPBLCheck", $TCPClient::BLCheckOptions).mType = "Master";
	}

	if(!$TCPClient::isTCPReady["Main"])
	{
		BLCheck_Reset("Main");
		$TCPClient::isTCPReady["Main"] = 1;
		connectToURL("http://www.blockland.us/index.html", "GET", "", "TCPBLCheck",    $TCPClient::BLCheckOptions).mType   = "Main";
	}
}

function TCPBLCheck::onConnected(%tcp)
{
	BLCheck_SetState(%tcp.mType, -1);
}

function TCPBLCheck::onDone(%tcp, %error)
{
	BLCheck_SetState(%tcp.mType, %error);
}

function BLCheck_Reset(%type)
{
	if(isObject(%button = nameToID("TCPSwatch_" @ %type @ "_Button")))
	{
		("TCPSwatch_" @ %type @ "_Check1").setVisible(0);
		("TCPSwatch_" @ %type @ "_Check2").setVisible(0);
		%button.setVisible(0);

		$TCPClient::TCPError[%type] = -1;
	}
}

function BLCheck_SetState(%type, %error)
{
	if(isObject(%button = nameToID("TCPSwatch_" @ %type @ "_Button")))
	{
		%check1 = nameToID("TCPSwatch_" @ %type @ "_Check1");
		%check2 = nameToID("TCPSwatch_" @ %type @ "_Check2");

		$TCPClient::TCPError[%type] = %error;
		if(%error == -1)
		{
			%check2.setBitmap("Add-Ons/Client_BLCheck/icons/warn.png");
			%check2.setVisible(1);

			%check1.setBitmap("Add-Ons/Client_BLCheck/icons/checkmark.png");
			%check1.setVisible(1);
		}
		else if(%error == $TCPClient::Error::dnsFailed)
		{
			%check1.setBitmap("Add-Ons/Client_BLCheck/icons/xmark.png");
			%check1.setVisible(1);
			$TCPClient::isTCPReady[%type] = 0;
		}
		else if(%error == $TCPClient::Error::connectionFailed || %error == $TCPClient::Error::connectionTimedOut)
		{
			%check2.setBitmap("Add-Ons/Client_BLCheck/icons/xmark.png");
			%check2.setVisible(1);
			$TCPClient::isTCPReady[%type] = 0;
		}
		else if(%error == $TCPClient::Error::invalidResponse || %error == 0)
		{
			%check2.setBitmap("Add-Ons/Client_BLCheck/icons/checkmark.png");
			%check2.setVisible(1);
			$TCPClient::isTCPReady[%type] = 0;
		}
		else
		{
			%check2.setBitmap("Add-Ons/Client_BLCheck/icons/xmark.png");
			%check2.setVisible(1);
			$TCPClient::isTCPReady[%type] = 0;
		}

		%button.setVisible(1);
	}
}